/**********************************************************************\
*                                                                      *
*  utility.c -- Information about snapshot, clip and convert           *
*                                                                      *
\**********************************************************************/

#include "defs.h"

/**********************************************************************\
*                                                                      *
*  about_snapshot -- information about the snapshot utility            *
*                                                                      *
\**********************************************************************/

int about_snapshot()
{
   static char *string[] = {
   "About SNAPSHOT",
   "SNAPSHOT is a TSR that you can use to capture",
   "graphic images and store them in pixel run files.",
   "Use your favorite paint program, CAD program, or",
   "any other method to display a graphic image and",
   "then use SNAPSHOT to create a file that Fastgraph",
   "can display."
   };

   /* clear the screen and display the info window */

   fg_mousevis(OFF);
   fg_restore(0,xlimit,menu_bottom,ylimit);
   info_window(120,520,60,string,7);

   /* wait for a keystroke or mouse button */

   fg_mousevis(ON);
   wait_for_keystroke();

   /* restore the screen and return to the menu */

   fg_mousevis(OFF);
   fg_restore(0,xlimit,menu_bottom,ylimit);

   fg_mousevis(ON);
   redraw = TRUE;

   return(OK);
}

/**********************************************************************\
*                                                                      *
*  about_clip -- information about the clip utility                    *
*                                                                      *
\**********************************************************************/

int about_clip()
{
   static char *string[] = {
   "About CLIP",
   "CLIP is a utility program that you can",
   "use to reduce the size of a pixel run file."
   };

   /* clear the screen and display the info window */

   fg_mousevis(OFF);
   fg_restore(0,xlimit,menu_bottom,ylimit);
   info_window(136,504,60,string,3);

   /* wait for a keystroke or mouse button */

   fg_mousevis(ON);
   wait_for_keystroke();

   /* restore the screen and return to the menu */

   fg_mousevis(OFF);
   fg_restore(0,xlimit,menu_bottom,ylimit);

   fg_mousevis(ON);
   redraw = TRUE;

   return(OK);
}

/**********************************************************************\
*                                                                      *
*  about_convert -- information about the clip utility                 *
*                                                                      *
\**********************************************************************/

int about_convert()
{
   static char *string[] = {
   "About CONVERT",
   "CONVERT is a utility program that you can use to",
   "translate pixel run files between standard format",
   "and packed format.  If an image contains 16 or",
   "fewer colors, you can pack it and save disk space."
   };

   fg_mousevis(OFF);
   /* clear the screen and display the info window */

   fg_restore(0,xlimit,menu_bottom,ylimit);
   info_window(120,520,60,string,5);

   /* wait for a keystroke or mouse button */

   fg_mousevis(ON);
   wait_for_keystroke();

   /* restore the screen and return to the menu */

   fg_mousevis(OFF);
   fg_restore(0,xlimit,menu_bottom,ylimit);

   fg_mousevis(ON);
   redraw = TRUE;

   return(OK);
}
